package be.iminds.ilabt.jfed.ui.javafx.am_list_gui;

import com.cathive.fx.guice.GuiceFXMLLoader;
import javafx.scene.Scene;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.StageStyle;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.io.IOException;

/**
 * User: twalcari
 * Date: 12/3/2014
 * Time: 13:39
 */
@Singleton
public class AddAuthorityDialogFactory {
    private static final Logger LOG = LoggerFactory.getLogger(AddAuthorityDialogFactory.class);
    private static final String ADD_AUTHORITY_DIALOG_FXML = "AddAuthorityDialog.fxml";
    private final GuiceFXMLLoader loader;

    @Inject
    AddAuthorityDialogFactory(GuiceFXMLLoader loader) {
        this.loader = loader;
    }


    public String showAddAuthorityDialog() {
        Stage stage = new Stage();
        stage.initStyle(StageStyle.UTILITY);
        stage.initModality(Modality.APPLICATION_MODAL);

        try {
            GuiceFXMLLoader.Result result = loader.load(getClass().getResource(ADD_AUTHORITY_DIALOG_FXML));
            AddAuthorityDialogController controller = result.getController();
            controller.setStage(stage);

            stage.setScene(new Scene(result.getRoot()));
            stage.sizeToScene();
            stage.showAndWait();

            if (controller.getAuthorityUrn() != null)
                return controller.getAuthorityUrn();
            else
                return null;
        } catch (IOException ex) {
            LOG.error("Error while loading AddAuthorityDialog", ex);
            return null;
        }
    }
}
