package be.iminds.ilabt.jfed.ui.javafx.scanner;

import be.iminds.ilabt.jfed.lowlevel.authority.SfaAuthority;
import com.cathive.fx.guice.GuiceFXMLLoader;
import javafx.scene.Scene;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.StageStyle;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.io.IOException;
import java.net.URL;

/**
 * User: twalcari
 * Date: 12/3/2014
 * Time: 12:06
 */
@Singleton
public class ScanAuthorityDialogFactory {
    private static final Logger LOG = LoggerFactory.getLogger(ScanAuthorityDialogFactory.class);
    private static final String SCAN_AUTHORITY_DIALOG_FXML = "ScanAuthorityDialog.fxml";

    private final GuiceFXMLLoader loader;

    @Inject
    ScanAuthorityDialogFactory(GuiceFXMLLoader loader) {
        this.loader = loader;
    }

    public SfaAuthority showScanAuthorityDialog() {
        Stage stage = new Stage();
        stage.initStyle(StageStyle.UTILITY);
        stage.initModality(Modality.APPLICATION_MODAL);

        try {
            URL location = getClass().getResource(SCAN_AUTHORITY_DIALOG_FXML);
            GuiceFXMLLoader.Result result = loader.load(location);

            ScanAuthorityDialogController controller = result.getController();
            controller.setStage(stage);

            stage.setScene(new Scene(result.getRoot()));
            stage.sizeToScene();
            stage.showAndWait();

            if (controller.getAMUrl() != null)
                return controller.getCreatedSfaAuthority();
            else
                return null;
        } catch (IOException ex) {
            LOG.error("Error while loading ScanAuthorityDialog", ex);
            return null;
        }
    }
}
