package be.iminds.ilabt.jfed.experimenter_gui;

import be.iminds.ilabt.jfed.experimenter_gui.dialogs.DialogsFactory;
import be.iminds.ilabt.jfed.experimenter_gui.dialogs.DialogsFactoryImpl;
import be.iminds.ilabt.jfed.experimenter_gui.slice.ExperimentViewController;
import be.iminds.ilabt.jfed.experimenter_gui.tasks.TasksFactory;
import be.iminds.ilabt.jfed.experimenter_gui.tasks.TasksFactoryImpl;
import be.iminds.ilabt.jfed.experimenter_gui.ui.ExperimentEditorListProvider;
import be.iminds.ilabt.jfed.experimenter_gui.ui.StatusUpdateListener;
import be.iminds.ilabt.jfed.experimenter_gui.ui.progressbar.TaskService;
import be.iminds.ilabt.jfed.util.GeniUrn;
import com.google.inject.AbstractModule;
import com.google.inject.Provides;
import javafx.application.HostServices;
import javafx.collections.FXCollections;
import javafx.collections.ObservableMap;
import javafx.stage.Stage;

import javax.inject.Singleton;

import static com.google.inject.name.Names.named;

/**
 * User: twalcari
 * Date: 12/1/2014
 * Time: 16:47
 */
public class ExperimenterModule extends AbstractModule {

    private final ObservableMap<GeniUrn, ExperimentViewController> experimentViewControllers =
            FXCollections.observableHashMap();

    @Provides
    @Singleton
    public ObservableMap<GeniUrn, ExperimentViewController> provideSliceControllersMap() {
        return experimentViewControllers;
    }

    @Provides
    public HostServices provideHostServices(Launch launch) {
        return launch.getHostServices();
    }

    @Provides
    @Singleton
    public StartupParameters provideStartupParameters(Launch launch) {
        return launch.getStartupParameters();
    }

    @Override
    protected void configure() {
        bind(Stage.class).annotatedWith(named("parentStage")).toProvider(Launch.class).in(Singleton.class);
        bind(StatusUpdateListener.class).to(ExperimenterGUI.class);
        bind(TaskService.class).to(ExperimenterGUI.class);
        bind(ExperimentsTabPaneProvider.class).to(ExperimenterGUI.class);
        bind(ExperimentEditorListProvider.class).to(ExperimenterGUI.class);

        bind(DialogsFactory.class).to(DialogsFactoryImpl.class);
        bind(TasksFactory.class).to(TasksFactoryImpl.class);

    }
}
