package be.iminds.ilabt.jfed.experimenter_gui.bugreporting;

import be.iminds.ilabt.jfed.call_log_output.CallReportReaderFactory;
import be.iminds.ilabt.jfed.log.cache.ApiCallDetailsCache;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.io.InputStream;
import java.io.Reader;

/**
 * User: twalcari
 * Date: 4/10/2015
 * Time: 16:31
 */
@Singleton
public class BugReportReaderFactory {

    private final ApiCallDetailsCache cache;
    private final CallReportReaderFactory callReportReaderFactory;

                                                               @Inject
    public BugReportReaderFactory(ApiCallDetailsCache cache, CallReportReaderFactory callReportReaderFactory) {
        this.cache = cache;
        this.callReportReaderFactory = callReportReaderFactory;
    }

    public BugReportReader createBugReportReader(InputStream inputStream){
        return new BugReportReader(inputStream, cache, callReportReaderFactory);
    }

    public BugReportReader createBugReportReader(Reader reader){
        return new BugReportReader(reader, cache, callReportReaderFactory);
    }
}
