package be.iminds.ilabt.jfed.experimenter_gui.call_gui;

import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import com.cathive.fx.guice.GuiceFXMLLoader;
import javafx.geometry.Rectangle2D;
import javafx.scene.Scene;
import javafx.stage.Screen;
import javafx.stage.Stage;

import javax.inject.Inject;
import javax.inject.Singleton;
import java.io.IOException;

/**
 * User: twalcari
 * Date: 3/11/14
 * Time: 2:16 PM
 */
@Singleton
public class TasksWindow {
    private static final String TASKS_PANEL_FXML = "Calls.fxml";
    private final Stage callsStage;
    private final GuiceFXMLLoader loader;
    private final TasksPanelController controller;

    @Inject
    TasksWindow(GuiceFXMLLoader loader) {
        this.loader = loader;

        //setup stage
        Rectangle2D primaryScreenBounds = Screen.getPrimary().getVisualBounds();

        callsStage = new Stage();
        callsStage.setX(primaryScreenBounds.getMinX());
        callsStage.setY(primaryScreenBounds.getMinY());
        callsStage.setWidth(primaryScreenBounds.getWidth());
        callsStage.setHeight(primaryScreenBounds.getHeight());
        callsStage.setMinHeight(480);
        callsStage.setMinWidth(640);
        callsStage.setTitle("jFed Calls Overview");

        TasksPanelController controller = null;

        //load TasksPanel
        try {
            GuiceFXMLLoader.Result result = loader.load(TasksWindow.class.getResource(TASKS_PANEL_FXML));
            callsStage.setScene(new Scene(result.getRoot()));
            controller = result.getController();
        } catch (IOException ex) {
            throw new RuntimeException("Error while loading TasksWindow", ex);
        }

        this.controller = controller;
    }

    public synchronized void showTasks() {
        assert callsStage != null;
        callsStage.show();
    }

    public void showTaskExecution(TaskExecution taskExecution) {
        controller.showTaskExecution(taskExecution);
        callsStage.show();
    }
}
