package be.iminds.ilabt.jfed.experimenter_gui.slice;

import be.iminds.ilabt.jfed.experimenter_gui.util.ExecuteOnNotNull;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import javafx.application.Platform;
import javafx.beans.property.BooleanProperty;
import javafx.beans.property.SimpleBooleanProperty;

/**
 * User: twalcari
 * Date: 2/5/2015
 * Time: 10:36
 */
public class ExperimentBindings {

    public static BooleanProperty createManifestNotAvailableBinding(Experiment experiment) {
        final BooleanProperty manifestNotAvailableProperty = new SimpleBooleanProperty(true);

        new ExecuteOnNotNull<Slice>(experiment.sliceProperty()) {

            @Override
            public void run() {
                Platform.runLater(() -> {
                    manifestNotAvailableProperty.bind(experiment.getSlice().manifestRspecProperty().isNull());
                });
            }
        };

        return manifestNotAvailableProperty;
    }

}
