package be.iminds.ilabt.jfed.experimenter_gui.slice.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.slice.Experiment;
import be.iminds.ilabt.jfed.highlevel.controller.HighLevelController;
import be.iminds.ilabt.jfed.highlevel.controller.Task;

import java.time.Instant;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;

/**
 * User: twalcari
 * Date: 2/2/2015
 * Time: 17:16
 */
public class RenewSliceTask extends SingleCallExperimentTask {

    private final Instant newExpirationDate;

    RenewSliceTask(Experiment experiment, Instant newExpirationDate, HighLevelController hlc) {
        super(experiment, hlc);
        this.newExpirationDate = newExpirationDate;

        updateTitle("Renew experiment until " + DateTimeFormatter.RFC_1123_DATE_TIME.format(ZonedDateTime.ofInstant(newExpirationDate, ZoneId.systemDefault())));
    }

    @Override
    public Task createTask() {
        return hlc.renewSlice(experiment.getSlice(), newExpirationDate, true /* renewAllSlivers */);
    }
}
