package be.iminds.ilabt.jfed.experimenter_gui.ui;

//import com.sun.javafx.collections.annotations.ReturnsUnmodifiableCollection;
import javafx.beans.binding.BooleanBinding;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

/**
 * User: twalcari
 * Date: 6/4/2014
 * Time: 17:18
 */
public class BindingsUtil {
    public static BooleanBinding instanceOfBinding(final ObservableValue observableValue, final Class clazz) {
        if (observableValue == null)
            throw new NullPointerException("ObservableValue cannot be null");
        if (clazz == null) {
            throw new NullPointerException("Class cannot be null");
        }

        return new BooleanBinding() {
            {
                super.bind(observableValue);
            }

            @Override
            public void dispose() {
                super.unbind(observableValue);
            }

            @Override
            protected boolean computeValue() {
                return clazz.isInstance(observableValue.getValue());
            }

            @Override
//            @ReturnsUnmodifiableCollection
            public ObservableList<?> getDependencies() {
                return FXCollections.singletonObservableList(observableValue);
            }
        };
    }
}
