package ch.ethz.ssh2.util;

import java.io.IOException;
import java.net.*;

/**
 * SocketWithCustomSocketFactory
 */
public class SocketWithCustomSocketFactory extends Socket {

    public SocketWithCustomSocketFactory(SocketImplFactory socketImplFactory, String host, int port) throws IOException {
        super(socketImplFactory.createSocketImpl());
        connect(host != null ?
                new InetSocketAddress(host, port) :
                new InetSocketAddress(InetAddress.getByName(null), port)
        );
    }

    public SocketWithCustomSocketFactory(SocketImplFactory socketImplFactory) throws SocketException {
        super(socketImplFactory.createSocketImpl());
    }

}
