package be.iminds.ilabt.jfed.lowlevel.connection;

import be.iminds.ilabt.jfed.lowlevel.JFedException;
import be.iminds.ilabt.jfed.util.ExtraInfoCallback;
import be.iminds.ilabt.jfed.util.JFedTrustStore;

import java.security.PrivateKey;
import java.security.cert.X509Certificate;
import java.util.List;

/**
 * ConnectionFactory
 */
public interface ConnectionFactory {
    RestSslNoAuthConnection createRestSslNoAuthConnection(
            String serverUrlString, final JFedTrustStore conTrustStore, JFedConnection.ProxyInfo usedProxyInfo,
            HandleUntrustedCallback handleUntrustedCallback, JFedConnection.DebugInfo debugInfo) throws JFedException;

    RestSslPasswordConnection createRestSslPasswordConnection(
            String serverUrlString, final JFedTrustStore conTrustStore, JFedConnection.ProxyInfo usedProxyInfo,
            ExtraInfoCallback.Login bonfireLogin,
            HandleUntrustedCallback handleUntrustedCallback, JFedConnection.DebugInfo debugInfo) throws JFedException;

    SfaConnection createSfaSslWithClientAuthConnection(
            String serverUrlStr, final JFedTrustStore conTrustStore, List<X509Certificate> clientCertChain, PrivateKey privateKey, JFedConnection.ProxyInfo usedProxyInfo,
            HandleUntrustedCallback handleUntrustedCallback, JFedConnection.DebugInfo debugInfo) throws JFedException;

    SfaConnection createSfaSslWithoutClientAuthConnection(
            String serverUrlStr, final JFedTrustStore conTrustStore, JFedConnection.ProxyInfo usedProxyInfo,
            HandleUntrustedCallback handleUntrustedCallback, JFedConnection.DebugInfo debugInfo) throws JFedException;

    SfaConnection createSfaPlainHttpConnection(String serverUrlStr, JFedConnection.ProxyInfo usedProxyInfo,
                                               JFedConnection.DebugInfo debugInfo) throws JFedException;
}
