package be.iminds.ilabt.jfed.rspec.model;

/**
 * HardwareType
 */
public class HardwareType {
    private final String name;
    private final Integer typeSlotsInt;
    private final String typeSlotsString;

    public HardwareType(String name, Integer typeSlotsInt, String typeSlotsString) {
        this.name = name;
        this.typeSlotsInt = typeSlotsInt;
        this.typeSlotsString = typeSlotsString;
        if (typeSlotsString == null)
            assert typeSlotsInt == null;
    }

    public String getName() {
        return name;
    }

    public Integer getTypeSlotsInt() {
        return typeSlotsInt;
    }
    public String getTypeSlotsString() {
        return typeSlotsString;
    }
    public boolean hasTypeSlots() {
        return typeSlotsString != null;
    }
    public boolean hasNumericTypeSlots() {
        return typeSlotsInt != null;
    }
    public boolean hasUnlimitedTypeSlots() {
        return typeSlotsString.trim().equalsIgnoreCase("unlimited");
    }
}
